import java.util.Scanner;

public class Squares {

    static int max_occurring_length = -1;
    static int number_of_squares_for_max_occurring_length = 0;

    private static int distanceIfAligned(int x1, int y1, int x2, int y2) {
        if((x1 == x2)) {
            return Math.abs(y2 - y1);
        } 
        if((y1 == y2)) {
            return Math.abs(x2 - x1);
        }
        return -1;
    }

    private static int checkIfSquare(int[] distances) {
        int countminus1 = 0;
        int countk = 0;

        // System.out.println("Distances = " + distances[0] + " " + distances[1] + " " + distances[2] + " " + distances[3] + " " + distances[4] + " " + distances[5]);

        int k = (distances[0] + distances[1]  + distances[2]  + distances[3]  + distances[4]  + distances[5] + 2) / 4; 

        for(int d : distances) {
            if(d == -1) countminus1++;
            if(d == k) countk++;
        }

        // System.out.println(countk + " " + countminus1);

        return ( (countk == 4) && (countminus1 == 2) ) ? k : -1;
    }


    private static void solveSquares(int [] x_coordinates, int [] y_coordinates) {
        /* ------------------- INSERT CODE HERE ---------------------
         * After finding the edge length corresponding to the maximum squares, 
         * assign it to the variable max_occurring_length and assign the number of 
         * squares with that length to variable number_of_squares_for_max_occurring_length. */

        /* We use the fact that maximum length of a side of the square is 100. */
        int[] counts = new int[101];

        for(int i = 0; i < 101; i++)
            counts[i] = 0;

        /* Go over all possibilities. */
        int num = x_coordinates.length;

        int[] distances = new int[6];
        for (int i1 = 0; i1 < num; i1++) {

            for (int i2 = i1+1; i2 < num; i2++) {
                distances[0] = distanceIfAligned(x_coordinates[i1], y_coordinates[i1], x_coordinates[i2], y_coordinates[i2]);

                for (int i3 = i2+1; i3 < num; i3++) {
                    distances[1] = distanceIfAligned(x_coordinates[i1], y_coordinates[i1], x_coordinates[i3], y_coordinates[i3]);
                    distances[2] = distanceIfAligned(x_coordinates[i2], y_coordinates[i2], x_coordinates[i3], y_coordinates[i3]);

                    for (int i4 =i3+1; i4 < num; i4++) {
                        distances[3] = distanceIfAligned(x_coordinates[i1], y_coordinates[i1], x_coordinates[i4], y_coordinates[i4]);
                        distances[4] = distanceIfAligned(x_coordinates[i2], y_coordinates[i2], x_coordinates[i4], y_coordinates[i4]);
                        distances[5] = distanceIfAligned(x_coordinates[i3], y_coordinates[i3], x_coordinates[i4], y_coordinates[i4]);

                        // System.out.println("Checking " + x_coordinates[i1] + " " + y_coordinates[i1] + "; " + x_coordinates[i2] + " " + y_coordinates[i2] + "; " + x_coordinates[i3] + " " + y_coordinates[i3] + "; " + x_coordinates[i4] + " " + y_coordinates[i4] + ";");

                        int k = checkIfSquare(distances);

                        if(k != -1) {
                            // System.out.println("incrementing " + k);
                            counts[k]++;
                        }
                    }
                }
            }
        }

        /*
        for(int i = 1; i < 101; i++) {
            if(counts[i] != 0) {
                System.out.println("length = " + i + ", count = " + counts[i]);
            }
        }
        */

        for(int i : counts) {
            if(number_of_squares_for_max_occurring_length < i)
                number_of_squares_for_max_occurring_length = i;
        }

        if(number_of_squares_for_max_occurring_length == 0)
            return;

        for(int i = 1; i < 101; i++) {
            if(counts[i] == number_of_squares_for_max_occurring_length) {
                assert(max_occurring_length == -1);
                max_occurring_length = i;
                assert(max_occurring_length == -1);
            }
        }

        /* -------------------- END OF INSERTION --------------------*/
    }
    
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);

        int numCases = sc.nextInt();

        for(int i = 0; i < numCases; i++) 
        {
            // System.out.println("-----------");
            int numberOfPoints = sc.nextInt();

            number_of_squares_for_max_occurring_length = 0;

            int[] x_coordinates = new int[numberOfPoints];
            int[] y_coordinates = new int[numberOfPoints];

            for(int j = 0; j < numberOfPoints; j++) {
                x_coordinates[j] = sc.nextInt();
                y_coordinates[j] = sc.nextInt();
            }

            solveSquares(x_coordinates, y_coordinates);

            if(number_of_squares_for_max_occurring_length != 0) {
                System.out.println("LENGTH = " + max_occurring_length + ", COUNT = " + number_of_squares_for_max_occurring_length);
            } else {
                System.out.println("No squares among the points.");
            }
        }
    }

}
