/*
Tron RotationMaze
=================

Each input case looks like this:
nx ny
XXXXXXXXXXX
XsX...X...X
X.X.X.X.X.X
X.X.X.X.X.X
X...X...XeX
XXXXXXXXXXX

where nx and ny are integers giving the number of columns and rows in the maze,
respectively. Following these numbers are ny lines, each of length nx. Each
character in these lines represents a cell of the maze. A "." character
represents an empty part of the maze (over which the ball can roll). The "s"
and "e" characters represent the starting and goal (end) positions of the ball,
respectively. Leading and trailing whitespace is removed. Any other character
represents an obstacle (a wall) that the ball cannot pass through. 

Notes:
  (1) It is possible for the ball to fall off the board (i.e. the maze does not
  have to be enclosed).

  (2) The start and end points do not need to be at the edge of the board.

  (3) If there is more than one sequence of rotations, return the shortest one.

  (4) If there are several shortest sequences, return the one that would come
  alphabetically first if viewed as a word.

  (5) If no solution exists, return NONE.
  
  (6) The board starts in the orientation as it is shown in the file (with
  gravity acting down the screen). The ball should be allowed to fall from its
  starting place (if it can) before any rotations occur.
*/

import java.util.Scanner;
import java.util.LinkedList;
import java.util.Set;
import java.util.HashSet;
import java.io.File;
import java.io.FileNotFoundException;

public class RotationMaze {
	
	/** The type of cell at a given location in the maze **/
	public enum BlockType {EMPTY, START, END, WALL};
	
	/** Find the shortest path through the maze **/
	public static String solveRotationMaze(
        BlockType [][] Maze, 
        int nx, int ny, 
        int startx, int starty) 
    {
        /* ------------------- INSERT CODE HERE ---------------------*/

        return "NONE";
        /* -------------------- END OF INSERTION --------------------*/
	}


	public static void main(String[] args) throws FileNotFoundException {
        //Scanner sc = new Scanner(new File("02.in"));
		Scanner sc = new Scanner(System.in);
        int numCases = sc.nextInt();

        for(int i = 0; i < numCases; i++) 
        {
        	// read the dimensions of the maze
            int nx = sc.nextInt();
            int ny = sc.nextInt();
            sc.nextLine();

            // create a 2-d array to hold the maze
            BlockType [][] Maze = new BlockType [nx][ny];
            int startx=-1, starty=-1;
            for(int j = 0; j < ny; j++)
            {
            	String line = sc.nextLine();
            	line = line.trim();
            	assert line.length() == nx;
            	
            	// scan the current line (j) of the maze
            	for (int c = 0; c < nx; c++)
            	{
            		switch(line.charAt(c))
            		{
            			case '.': Maze[c][j] = BlockType.EMPTY; break;
            			case 's': Maze[c][j] = BlockType.START; startx=c; starty=j; break;
            			case 'e': Maze[c][j] = BlockType.END; break;
            			default: Maze[c][j] = BlockType.WALL; break;
            		}
            	}
            }

            assert startx >= 0 && starty >= 0;
            System.out.println("Case " + (i+1) + ": " + solveRotationMaze(Maze, nx, ny, startx, starty));
        }
	}
}

