import java.util.Scanner;


public class BoardCuttingGameNoLimit {

    final static int L = 0, R = 1;

    final static int MAXN = 402;

    static int d[][] = new int[MAXN][MAXN];

    static int move[][] = new int[MAXN][MAXN];

    static boolean mark[][] = new boolean[MAXN][MAXN];

    public static int comp(int[] seq, int x, int y) {
        if (! mark[x][y]) {
            mark[x][y] = true;
            if (x == y) 
                d[x][y] = seq[x];  /* Base case. */
            else {

                /* What's the maximum score assuming we choose from the left end). */
                int lmv = seq[x] - comp(seq, x+1, y);

                int rmv = seq[y] - comp(seq, x, y-1);

                if (lmv > rmv) {
                    d[x][y] = lmv;
                    move[x][y] = L;
                } else {
                    d[x][y] = rmv;
                    move[x][y] = R;
                }
            }
        }
        return d[x][y];
    }

    public static boolean solveBoardCuttingGame(int[] seq) {
        /* Your code should set the following variable to true if the first player has a winning strategy. */
        boolean firstPlayerHasWinningStrategy = false;

        /* Initialize the mark array. */
        for (int i = 0; i < MAXN; i++)
            for (int j = 0; j < MAXN; j++)
                            mark[i][j] = false;

        /* This recursive call calculates the dynamic programming table. */
        comp(seq, 0, seq.length-1);

        firstPlayerHasWinningStrategy = (d[0][seq.length-1] >= 0);

        return firstPlayerHasWinningStrategy;

    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);

        int numCases = sc.nextInt();

        for(int i = 0; i < numCases; i++) 
        {
            int numberOfHeaps = sc.nextInt();

            int[] seq = new int[numberOfHeaps];

            for(int j = 0; j < numberOfHeaps; j++) {
                seq[j] = sc.nextInt();
            }

            if(solveBoardCuttingGame(seq)) {
                System.out.println("YES");
            } else {
                System.out.println("NO");
            }

            /* Debuggin Code
            for(int i1 = 0; i1 < numberOfHeaps; i1++) {
                for(int i2 = 0; i2 < numberOfHeaps; i2++) 
                    System.out.print(d[i1][i2] + "-" + move[i1][i2] + "	");
                System.out.println();
            }

            int l = 0, r = numberOfHeaps-1;
            for(int i1 = 0; i1 < numberOfHeaps; i1++) {
                if(move[l][r] == L) {
                    System.out.println( ((i1%2 == 0) ? "Left takes from left " : "Right takes from left ") + seq[l]);
                    l++;
                } else {
                    System.out.println( ((i1%2 == 0) ? "Left takes from right " : "Right takes from right ") + seq[r]);
                    r--;
                }
            }
            */
        }
    }
}
