import java.util.Scanner;


public class GridNim {

    final static int L = 0, R = 1;

    final static int LIMIT = 3;

    final static int MAXN = 401;

    static int d[][][][][] = new int[MAXN][MAXN][2][LIMIT][LIMIT];

    static int move[][][][][] = new int[MAXN][MAXN][2][LIMIT][LIMIT];

    static boolean mark[][][][][] = new boolean[MAXN][MAXN][2][LIMIT][LIMIT];

    public static int comp(int[] seq, int x, int y, int s, int l2, int l1) {
        if (! mark[x][y][s][l2][l1]) {
            mark[x][y][s][l2][l1] = true;
            if (x == y) 
                d[x][y][s][l2][l1] = seq[x];  /* Base case. */
            else {

                /* What's the maximum score assuming we choose from the left end). */
                int lmv;
                if (s == L)
                    lmv = seq[x] - comp(seq, x+1, y, L, 1, 0); // since the other player's prior move was on L side, no issues with us choosing from that side.
                                                               // reset l1 and l2
                else if (l1 < LIMIT - 1)
                    lmv = seq[x] - comp(seq, x+1, y, L, l1+1, l2); // if our prior move was on L side, we can only choose L again if l1 < LIMIT - 1
                else 
                    lmv = - (1<<29); // our prior move was on L side and l1 = LIMIT, so we can't choose from that side again. set lmv to very large -ve value.

                /* What's the maximum score assuming we choose from the right end). The calculation is symmetric. */
                int rmv;
                if (s == R)
                    rmv = seq[y] - comp(seq, x, y-1, R, 1, 0);
                else if (l1 < LIMIT - 1)
                    rmv = seq[y] - comp(seq, x, y-1, R, l1+1, l2);
                else
                    rmv = - (1<<29);

                if (lmv > rmv) {
                    d[x][y][s][l2][l1] = lmv;
                    move[x][y][s][l2][l1] = L;
                } else {
                    d[x][y][s][l2][l1] = rmv;
                    move[x][y][s][l2][l1] = R;
                }
            }
        }
        return d[x][y][s][l2][l1];
    }



    public static boolean solveGridNim(int[] seq) {
        /* Your code should set the following variable to true if the first player has a winning strategy. */
        boolean firstPlayerHasWinningStrategy = false;

        /* ------------------- INSERT CODE HERE ---------------------*/

        /* We will use dynamic programming to solve the problem. 
         *
         * We will use two multi-dimensional arrays for this purpose. 
         *
         * d[i][j][s][l2][l1]: records the maximum score of the player when:
         *      (1) restricted only to elements from i to j
         *      (2) the previous player has chosen l2 consecutive elements from side s (which is boolean: left or right).
         *      (3) we have chosen l1 consecutive elements from the other side.
         *
         *      Both l2 and l2 must be less than 3 (LIMIT).
         *
         * mark[i][j][s][l2][l1]: simply records if the corresponding entry in d[][][][][] is valid or not.
         * */

        // d = new int[seq.length][seq.length][2][LIMIT][LIMIT]; 

        // mark = new boolean[seq.length][seq.length][2][LIMIT][LIMIT]; 

        /* Initialize the mark array. */
        for (int i = 0; i < MAXN; i++)
            for (int j = 0; j < MAXN; j++)
                for (int s = 0; s < 2; s++)
                    for (int l2 = 0; l2 < LIMIT; l2++)
                        for (int l1 = 0; l1 < LIMIT; l1++)
                            mark[i][j][s][l2][l1]=false;

        /* This recursive call calculates the dynamic programming table. */
        comp(seq, 0, seq.length-1, L, 0, 0);

        firstPlayerHasWinningStrategy = (d[0][seq.length-1][L][0][0] >= 0);

        return firstPlayerHasWinningStrategy;

    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);

        int numCases = sc.nextInt();

        for(int i = 0; i < numCases; i++) 
        {
            int numberOfHeaps = sc.nextInt();

            int[] seq = new int[numberOfHeaps];

            for(int j = 0; j < numberOfHeaps; j++) {
                seq[j] = sc.nextInt();
            }

            if(solveGridNim(seq)) {
                System.out.println("YES");
            } else {
                System.out.println("NO");
            }

            /* Debugging Code 
            int l = 0, r = numberOfHeaps-1, l1 = 0, l2 = 0, lastmove = L;
            System.out.println(d[l][r][lastmove][l2][l1]);
            for(int i1 = 0; i1 < numberOfHeaps; i1++) {
                if(move[l][r][lastmove][l2][l1] == L) {
                    System.out.println( ((i1%2 == 0) ? "Left takes from left " : "Right takes from left ") + seq[l]);

                    if(lastmove == L) {
                        l2 = 1; l1 = 0;
                    } else {
                        int temp = l1; l1 = l2; l2 = temp + 1;
                    }

                    lastmove = L;
                    l++;
                } else {
                    System.out.println( ((i1%2 == 0) ? "Left takes from right " : "Right takes from right ") + seq[r]);

                    if(lastmove == R) {
                        l2 = 1; l1 = 0;
                    } else {
                        int temp = l1; l1 = l2; l2 = temp + 1;
                    }

                    lastmove = R;
                    r--;
                }
            }
            */
        }
    }
}
