import java.util.*;

public class TronChange {

    static int num_solutions = 0;
	
	/** 
	 *  main program
	 */
	public static void main(String[] args) throws Exception {
										// read input
		Scanner scanner = new Scanner(System.in);
        int numCases = scanner.nextInt();

        for(int t = 0; t < numCases; t++) {
            int n = scanner.nextInt();		// input number of reciprocals

            num_solutions = 0;

            if (n <= 0) {
                System.out.println("Error: Need at least 1 coin");
                System.exit(0);
            }
            int r = scanner.nextInt();		// input number of repetitions
            if (r < 0) {
                System.out.println("Error: Repetition count must be nonnegative");
                System.exit(0);
            }

            int f = scanner.nextInt(); 		// number of forbidden values
            int[] F = new int[f];			// list of forbidden values
            for (int i = 0; i < f; i++) {	// input forbidden
                F[i] = scanner.nextInt();
                if (F[i] <= 0) {
                    System.out.println("Error: Forbidden values must be positive");
                    System.exit(0);
                }
            }

            // print input summary
            System.out.print("Case " + (t+1) + " " + ": Number of coins = " + n + "; Repetitions = " + r + "; Forbidden = [");
            if(F.length != 0) {
                System.out.print(F[0]);
                for (int i = 1; i < F.length; i++)
                    System.out.print(" " + F[i]);
            }
            System.out.println("]");

            makeChange(n, r, F); // solve

            // print output summary
            if (num_solutions == 0) {
                System.out.println("No solutions found");
            } else {		
                System.out.println(num_solutions + " solutions found");
            }
        }
	}
	
    /* Use this to print one solution. */
    private static void printOneOutput(int[] coins) {
        num_solutions++;

        for(int i = 0; i < coins.length - 1; i++) {
            System.out.print(coins[i] + " ");
        }
    }

    /* Solve the problem, and for each generated solution, call printOneOutput to print
     * out the solutions. */
	private static void makeChange(
		int n,			// number of coins to use
		int r, 			// maximum number of repetitions per coin
		int[] F) 		// forbidden coins
	{

        /* INSERT CODE HERE */
	}
}
